Debian Bug report logs - #604926
libm17n-0: circular dependencies with m17n-contrib and m17n-db

version graph

Package: m17n-db; Maintainer for m17n-db is Harshula Jayasuriya <harshula@debian.org>; Source for m17n-db is src:m17n-db.

Reported by: Bill Allombert <ballombe@debian.org>

Date: Thu, 25 Nov 2010 13:15:01 UTC

Severity: important

Fixed in version m17n-db/1.6.2-2

Done: Harshula Jayasuriya <harshula@gmail.com>

Bug is archived. No further changes may be made.

Toggle useless messages

View this report as an mbox folder, status mbox, maintainer mbox


Report forwarded to debian-bugs-dist@lists.debian.org, Harshula Jayasuriya <harshula@gmail.com>:
Bug#604926; Package libm17n-0. (Thu, 25 Nov 2010 13:15:04 GMT) Full text and rfc822 format available.

Acknowledgement sent to Bill Allombert <ballombe@debian.org>:
New Bug report received and forwarded. Copy sent to Harshula Jayasuriya <harshula@gmail.com>. (Thu, 25 Nov 2010 13:15:04 GMT) Full text and rfc822 format available.

Message #5 received at submit@bugs.debian.org (full text, mbox):

From: Bill Allombert <ballombe@debian.org>
To: submit@bugs.debian.org
Subject: libm17n-0: circular dependencies with m17n-contrib and m17n-db
Date: Thu, 25 Nov 2010 14:10:20 +0100
Package: libm17n-0
Version: 1.6.2-1
Severity: important

Hello Harshula,

There is a circular dependency between libm17n-0, m17n-contrib and m17n-db:

libm17n-0 	:Depends: m17n-db (>= 1.6.0), m17n-contrib
m17n-contrib 	:Depends: libm17n-0 (>= 1.5.0), m17n-db (>= 1.5.0)
m17n-db 	:Depends: libm17n-0 (>= 1.6.0)

Complex circular dependencies, especially involving shared libraries, are known
to cause problems during upgrade, so we should try to get rid of them.

See threads 
http://lists.debian.org/debian-devel/2005/06/msg02111.html
http://lists.debian.org/debian-devel/2005/11/msg01101.html

Cheers,
-- 
Bill. <ballombe@debian.org>

Imagine a large red swirl here. 




Information forwarded to debian-bugs-dist@lists.debian.org, Harshula Jayasuriya <harshula@gmail.com>:
Bug#604926; Package libm17n-0. (Sun, 05 Dec 2010 15:54:03 GMT) Full text and rfc822 format available.

Acknowledgement sent to Harshula <harshula@gmail.com>:
Extra info received and forwarded to list. Copy sent to Harshula Jayasuriya <harshula@gmail.com>. (Sun, 05 Dec 2010 15:54:03 GMT) Full text and rfc822 format available.

Message #10 received at 604926@bugs.debian.org (full text, mbox):

From: Harshula <harshula@gmail.com>
To: Bill Allombert <ballombe@debian.org>, 604926@bugs.debian.org
Subject: Re: Bug#604926: libm17n-0: circular dependencies with m17n-contrib and m17n-db
Date: Mon, 06 Dec 2010 02:35:42 +1100
Hi Bill,

Thanks for bringing this to my attention.

On Thu, 2010-11-25 at 14:10 +0100, Bill Allombert wrote:

> There is a circular dependency between libm17n-0, m17n-contrib and m17n-db:
> 
> libm17n-0 	:Depends: m17n-db (>= 1.6.0), m17n-contrib
> m17n-contrib 	:Depends: libm17n-0 (>= 1.5.0), m17n-db (>= 1.5.0)
> m17n-db 	:Depends: libm17n-0 (>= 1.6.0)

Would you suggest:
libm17n-0	: Depends: m17n-db (>= 1.6.0), m17n-contrib
m17n-contrib	: Depends: m17n-db (>= 1.5.0) ; Recommends: libm17n-0 (>=
1.5.0)
m17n-db		: Recommends: libm17n-0 (>= 1.6.0)

m17n-db & m17n-contrib contain data that is used by libm17n-0.

cya,
#





Information forwarded to debian-bugs-dist@lists.debian.org, Harshula Jayasuriya <harshula@gmail.com>:
Bug#604926; Package libm17n-0. (Sun, 05 Dec 2010 16:33:03 GMT) Full text and rfc822 format available.

Acknowledgement sent to Bill Allombert <Bill.Allombert@math.u-bordeaux1.fr>:
Extra info received and forwarded to list. Copy sent to Harshula Jayasuriya <harshula@gmail.com>. (Sun, 05 Dec 2010 16:33:03 GMT) Full text and rfc822 format available.

Message #15 received at 604926@bugs.debian.org (full text, mbox):

From: Bill Allombert <Bill.Allombert@math.u-bordeaux1.fr>
To: Harshula <harshula@gmail.com>
Cc: 604926@bugs.debian.org
Subject: Re: Bug#604926: libm17n-0: circular dependencies with m17n-contrib and m17n-db
Date: Sun, 5 Dec 2010 17:28:37 +0100
On Mon, Dec 06, 2010 at 02:35:42AM +1100, Harshula wrote:
> Hi Bill,
> 
> Thanks for bringing this to my attention.
> 
> On Thu, 2010-11-25 at 14:10 +0100, Bill Allombert wrote:
> 
> > There is a circular dependency between libm17n-0, m17n-contrib and m17n-db:
> > 
> > libm17n-0 	:Depends: m17n-db (>= 1.6.0), m17n-contrib
> > m17n-contrib 	:Depends: libm17n-0 (>= 1.5.0), m17n-db (>= 1.5.0)
> > m17n-db 	:Depends: libm17n-0 (>= 1.6.0)
> 
> Would you suggest:
> libm17n-0	: Depends: m17n-db (>= 1.6.0), m17n-contrib
> m17n-contrib	: Depends: m17n-db (>= 1.5.0) ; Recommends: libm17n-0 (>=
> 1.5.0)
> m17n-db		: Recommends: libm17n-0 (>= 1.6.0)
> 
> m17n-db & m17n-contrib contain data that is used by libm17n-0.

Hello Harshula!

It seems that neither m17n-contrib nor m17n-db actually needs libm17n-0 to work,
so it should be fine. The Recommends are OK thought I do not find them 
useful here (by itself, libm17n-0 does not provide any functionnality without at
least one program linked against libm17n-0).

I would suggest to move /usr/share/man/man1/m17n-db.1.gz from m17n-docs to
m17n-db if possible. It is often better for program manpage to be in the same
package as the program. This would require m17n-db to Replace m17n-docs though.

Cheers,
Bill.




Information forwarded to debian-bugs-dist@lists.debian.org, Harshula Jayasuriya <harshula@gmail.com>:
Bug#604926; Package libm17n-0. (Wed, 05 Jan 2011 19:45:03 GMT) Full text and rfc822 format available.

Acknowledgement sent to Luca Capello <luca@pca.it>:
Extra info received and forwarded to list. Copy sent to Harshula Jayasuriya <harshula@gmail.com>. (Wed, 05 Jan 2011 19:45:03 GMT) Full text and rfc822 format available.

Message #20 received at 604926@bugs.debian.org (full text, mbox):

From: Luca Capello <luca@pca.it>
To: 604926@bugs.debian.org
Cc: Bill Allombert <Bill.Allombert@math.u-bordeaux1.fr>, Harshula <harshula@gmail.com>, Josh Triplett <josh@joshtriplett.org>
Subject: Re: Bug#604926: libm17n-0: circular dependencies with m17n-contrib and m17n-db
Date: Wed, 05 Jan 2011 20:42:56 +0100
[Message part 1 (text/plain, inline)]
Hi there!

On Sun, 05 Dec 2010 17:28:37 +0100, Bill Allombert wrote:
> It seems that neither m17n-contrib nor m17n-db actually needs libm17n-0 to work,
> so it should be fine. The Recommends are OK thought I do not find them 
> useful here (by itself, libm17n-0 does not provide any functionnality without at
> least one program linked against libm17n-0).

Actually, the Depends: were added to fix #599643 (cc:ing the original
submitter), which I was re-opening when I found out it via an upgrade.

I consider it a bug that a library depends on a database to be used.
First, because the database could be provided *directly* by the sysadmin
(thus without the need for the exact copy provided by the dependent
packages) and, second, because it means that a program linked to that
library will require the dependent packages.

The last point is an interesting one, which the original submitter
summarizes in the bug report:

  Message-ID: <20101011005324.GC2521@feather>
  URL: <http://bugs.debian.org/cgi-bin/bugreport.cgi?bug=599643#13>

I will quote only the last part of his post, however please read it
entirely before replying.

On Mon, 11 Oct 2010 02:53:25 +0200, Josh Triplett wrote:
> But again, it seems questionable why someone would want to cripple m17n
> by not installing those packages.  Similarly, someone *could* omit key
> pieces of emacs, such as major modes for uncommon languages, and put
> them in a separate package with a Recommends; however, those represent a
> sufficiently expected part of the functionality of emacs that they need
> a Depends-level "always installed" relationship.
>
> By contrast, gdm3 only Recommends xserver-xephyr, because it can use
> xephyr to implement the nested login functionality, but people wouldn't
> consider gdm3 *broken* without that functionality.

Emacs is not *broken* without the m17n-contrib and m17n-db packages, it
is one of its *functionalities* which is broken, quite a different
thing, mostly the same as the original submitter gdm3 example.

Recommends: are there exactly for that, especially given that "Emacs +
libm17n-0 + m17n-contrib + m17n-db" *does not work*, as explained by the
Debian maintainer in reply to the post above:

  Message-ID: <1286876519.31024.79.camel@B3.HOME>
  URL: <http://bugs.debian.org/cgi-bin/bugreport.cgi?bug=599643#18>

On Tue, 12 Oct 2010 11:41:59 +0200, Harshula wrote:
> On Sun, 2010-10-10 at 17:53 -0700, Josh Triplett wrote:
>> On Mon, Oct 11, 2010 at 03:43:27AM +1100, Harshula wrote:

>> > You've raised an interesting question. My initial reaction is Emacs
>> > should Depend on both libm17n-0 and m17n-db. Emacs appears to use
>> > libm17n and m17n-db for complex text layout. libm17n contains the C API
>> > and m17n-db contains the layout rules. So without both packages Emacs
>> > will not function correctly. For example, copy the following Sinhala
>> > text "කොහොමද" into Emacs with both libm17n-0 and m17n-db installed. Take
>> > a screenshot. Then remove m17n-db and copy the text into Emacs and see
>> > the difference.
>> 
>> Interesting.  It didn't make a difference with the default font I
>> normally use in Emacs (Neep Alt), but with DejaVu Sans Mono the first
>> character moved before the quote.  Does that sound like the correct
>> behavior?
>
> No, that does not sound correct. I forgot to mention one important step,
> install ttf-sinhala-lklug.

According to the reasoning used to solve #599643, why does libm17n-0 not
depend also on ttf-sinhala-lklug?  It does not even Recommends: it...

Please, reconsider the Depends: on m17n-contrib nor m17n-db, which
should stay as Recommends:, and add an hint into the libm17n-0
Description: about the needed packages, both data *and* font(s).

Thx, bye,
Gismo / Luca
[Message part 2 (application/pgp-signature, inline)]

Information forwarded to debian-bugs-dist@lists.debian.org, Harshula Jayasuriya <harshula@gmail.com>:
Bug#604926; Package libm17n-0. (Wed, 05 Jan 2011 22:18:06 GMT) Full text and rfc822 format available.

Acknowledgement sent to Bill Allombert <Bill.Allombert@math.u-bordeaux1.fr>:
Extra info received and forwarded to list. Copy sent to Harshula Jayasuriya <harshula@gmail.com>. (Wed, 05 Jan 2011 22:18:06 GMT) Full text and rfc822 format available.

Message #25 received at 604926@bugs.debian.org (full text, mbox):

From: Bill Allombert <Bill.Allombert@math.u-bordeaux1.fr>
To: Luca Capello <luca@pca.it>
Cc: 604926@bugs.debian.org, Harshula <harshula@gmail.com>, Josh Triplett <josh@joshtriplett.org>
Subject: Re: Bug#604926: libm17n-0: circular dependencies with m17n-contrib and m17n-db
Date: Wed, 5 Jan 2011 23:13:50 +0100
On Wed, Jan 05, 2011 at 08:42:56PM +0100, Luca Capello wrote:
> Hi there!
> 
> On Sun, 05 Dec 2010 17:28:37 +0100, Bill Allombert wrote:
> > It seems that neither m17n-contrib nor m17n-db actually needs libm17n-0 to work,
> > so it should be fine. The Recommends are OK thought I do not find them 
> > useful here (by itself, libm17n-0 does not provide any functionnality without at
> > least one program linked against libm17n-0).
> 
> Actually, the Depends: were added to fix #599643 (cc:ing the original
> submitter), which I was re-opening when I found out it via an upgrade.

This is not the case: the Depends that was added was 
libm17n-0: Depends: m17n-contrib, m17n-db,

but I was talking about the dependencies:
m17n-contrib: Depends: libm17n-0 
m17n-db     : Depends: libm17n-0

Cheers,
-- 
Bill. <ballombe@debian.org>

Imagine a large red swirl here. 




Information forwarded to debian-bugs-dist@lists.debian.org, Harshula Jayasuriya <harshula@gmail.com>:
Bug#604926; Package libm17n-0. (Sun, 09 Jan 2011 13:45:06 GMT) Full text and rfc822 format available.

Acknowledgement sent to Harshula <harshula@gmail.com>:
Extra info received and forwarded to list. Copy sent to Harshula Jayasuriya <harshula@gmail.com>. (Sun, 09 Jan 2011 13:45:06 GMT) Full text and rfc822 format available.

Message #30 received at 604926@bugs.debian.org (full text, mbox):

From: Harshula <harshula@gmail.com>
To: Bill Allombert <Bill.Allombert@math.u-bordeaux1.fr>
Cc: 604926@bugs.debian.org
Subject: Re: Bug#604926: libm17n-0: circular dependencies with m17n-contrib and m17n-db
Date: Mon, 10 Jan 2011 00:37:13 +1100
On Sun, 2010-12-05 at 17:28 +0100, Bill Allombert wrote:

> I would suggest to move /usr/share/man/man1/m17n-db.1.gz from m17n-docs to
> m17n-db if possible. It is often better for program manpage to be in the same
> package as the program. This would require m17n-db to Replace m17n-docs though.

m17n-docs 1.5.5 changed its license to GFDL with no Invariant Sections.
It's waiting in the NEW queue. So once that is uploaded to Main I could
make m17n-db Depends or Recommends on m17n-docs. I'd prefer not to pull
out the man pages of executables from m17n-docs.

cya,
#





Information forwarded to debian-bugs-dist@lists.debian.org, Harshula Jayasuriya <harshula@gmail.com>:
Bug#604926; Package libm17n-0. (Sun, 09 Jan 2011 15:00:05 GMT) Full text and rfc822 format available.

Acknowledgement sent to Harshula <harshula@gmail.com>:
Extra info received and forwarded to list. Copy sent to Harshula Jayasuriya <harshula@gmail.com>. (Sun, 09 Jan 2011 15:00:05 GMT) Full text and rfc822 format available.

Message #35 received at 604926@bugs.debian.org (full text, mbox):

From: Harshula <harshula@gmail.com>
To: Luca Capello <luca@pca.it>
Cc: 604926@bugs.debian.org, Bill Allombert <Bill.Allombert@math.u-bordeaux1.fr>, Josh Triplett <josh@joshtriplett.org>
Subject: Re: Bug#604926: libm17n-0: circular dependencies with m17n-contrib and m17n-db
Date: Mon, 10 Jan 2011 01:56:22 +1100
Hi Luca,

Do you use m17n lib or have you used it before?

On Wed, 2011-01-05 at 20:42 +0100, Luca Capello wrote:
> On Sun, 05 Dec 2010 17:28:37 +0100, Bill Allombert wrote:

> I consider it a bug that a library depends on a database to be used.
> First, because the database could be provided *directly* by the sysadmin
> (thus without the need for the exact copy provided by the dependent
> packages) and, second, because it means that a program linked to that
> library will require the dependent packages.

The programs that link to the m17n library do so to use the rules
contained in m17n-db.

> Recommends: are there exactly for that, especially given that "Emacs +
> libm17n-0 + m17n-contrib + m17n-db" *does not work*, as explained by the
> Debian maintainer in reply to the post above:

No, that's not what I said. If you are typing in a particular script,
you need the relevant font to see the correct results. This is
applicable to other text layout libraries.

> According to the reasoning used to solve #599643, why does libm17n-0 not
> depend also on ttf-sinhala-lklug?  It does not even Recommends: it...

Pango or ICU do not depend on particular fonts either.

cya,
#





Bug reassigned from package 'libm17n-0' to 'm17n-db'. Request was from Harshula <harshula@gmail.com> to control@bugs.debian.org. (Sun, 09 Jan 2011 15:12:05 GMT) Full text and rfc822 format available.

Bug No longer marked as found in versions m17n-lib/1.6.2-1. Request was from Harshula <harshula@gmail.com> to control@bugs.debian.org. (Sun, 09 Jan 2011 15:12:06 GMT) Full text and rfc822 format available.

Information forwarded to debian-bugs-dist@lists.debian.org, Harshula Jayasuriya <harshula@gmail.com>:
Bug#604926; Package m17n-db. (Sun, 16 Jan 2011 21:39:03 GMT) Full text and rfc822 format available.

Acknowledgement sent to Luca Capello <luca@pca.it>:
Extra info received and forwarded to list. Copy sent to Harshula Jayasuriya <harshula@gmail.com>. (Sun, 16 Jan 2011 21:39:03 GMT) Full text and rfc822 format available.

Message #44 received at 604926@bugs.debian.org (full text, mbox):

From: Luca Capello <luca@pca.it>
To: Harshula <harshula@gmail.com>
Cc: 604926@bugs.debian.org, Bill Allombert <Bill.Allombert@math.u-bordeaux1.fr>, Josh Triplett <josh@joshtriplett.org>
Subject: Re: Bug#604926: libm17n-0: circular dependencies with m17n-contrib and m17n-db
Date: Sun, 16 Jan 2011 22:37:14 +0100
[Message part 1 (text/plain, inline)]
Hi Harshula!

I am sorry, it seems I missed your reply.

On Sun, 09 Jan 2011 15:56:22 +0100, Harshula wrote:
> Do you use m17n lib or have you used it before?

No, I have never used it, but the library was installed because of
emacs-snapshot and it will always be installed on my primary sid because
of that (or emacs23 or emacs24 or whatever).

FWIW, however, I have already written in Japanese katakana on a terminal
Emacs using ttf-unifont.

> On Wed, 2011-01-05 at 20:42 +0100, Luca Capello wrote:
>> I consider it a bug that a library depends on a database to be used.
>> First, because the database could be provided *directly* by the sysadmin
>> (thus without the need for the exact copy provided by the dependent
>> packages) and, second, because it means that a program linked to that
>> library will require the dependent packages.
>
> The programs that link to the m17n library do so to use the rules
> contained in m17n-db.

Every time these programs run?  I have not seen any Emacs error in more
than 6 years of use because of m17n-db not being installed on my sid (I
have APT's Install-Recommends off and pay attention to most extra
packages are installed as Depends:).

As a side note, now that I looked for, it is funny what upstream thinks
about the relationship between the m17n library and database, from
libm17n-0/1.6.1-1 /usr/share/doc/libm17n-0/README.gz:

  (2) DATABASE

  The m17n library utilizes the m17n database available at:
          http://www.m17n.org/m17n-lib/m17n-db
  Without this database, the m17n library loses half its value.  Please
  install it (Ver.1.4.0 or the later is required) too before you try the
  above sample programs or develop a program that uses the m17n library.

>> Recommends: are there exactly for that, especially given that "Emacs +
>> libm17n-0 + m17n-contrib + m17n-db" *does not work*, as explained by the
>> Debian maintainer in reply to the post above:
>
> No, that's not what I said.

Sorry, maybe my English is not so good, but this is how I read:

  Message-ID: <1286876519.31024.79.camel@B3.HOME>
  URL: <http://bugs.debian.org/cgi-bin/bugreport.cgi?bug=599643#18>

--8<---------------cut here---------------start------------->8---
On Tue, 12 Oct 2010 11:41:59 +0200, Harshula wrote:
> On Sun, 2010-10-10 at 17:53 -0700, Josh Triplett wrote:
>> On Mon, Oct 11, 2010 at 03:43:27AM +1100, Harshula wrote:
>
>> > You've raised an interesting question. My initial reaction is Emacs
>> > should Depend on both libm17n-0 and m17n-db. Emacs appears to use
>> > libm17n and m17n-db for complex text layout. libm17n contains the C API
>> > and m17n-db contains the layout rules. So without both packages Emacs
>> > will not function correctly. For example, copy the following Sinhala
>> > text "කොහොමද" into Emacs with both libm17n-0 and m17n-db installed. Take
>> > a screenshot. Then remove m17n-db and copy the text into Emacs and see
>> > the difference.
>> 
>> Interesting.  It didn't make a difference with the default font I
>> normally use in Emacs (Neep Alt), but with DejaVu Sans Mono the first
>> character moved before the quote.  Does that sound like the correct
>> behavior?
>
> No, that does not sound correct. I forgot to mention one important step,
> install ttf-sinhala-lklug.
--8<---------------cut here---------------end--------------->8---

Nevertheless, read below.

> If you are typing in a particular script, you need the relevant font
> to see the correct results. This is applicable to other text layout
> libraries.

To which I fully agree.

>> According to the reasoning used to solve #599643, why does libm17n-0 not
>> depend also on ttf-sinhala-lklug?  It does not even Recommends: it...
>
> Pango or ICU do not depend on particular fonts either.

Exactly, but at least libpango1.0/1.28.3-4 in experimental had the
following in its description:

  Recommends: x-ttcidfont-conf
  Suggests: ttf-japanese-gothic, ttf-japanese-mincho, ttf-thryomanes,
   ttf-baekmuk, ttf-arphic-gbsn00lp, ttf-arphic-bsmi00lp,
   ttf-arphic-gkai00mp, ttf-arphic-bkai00mp 

Anyway, given that:

- you reassigned this bug to m17n-db instead of libm17n-0
    <http://bugs.debian.org/cgi-bin/bugreport.cgi?msg=37;bug=604926>

- it seems you consider the libm17n0's Depends: on m17n-db and
  m17n-contrib (solution for #599643) a must

  NB1, funny that the original submitter of #599643 asked for an
       explication of these Recommends: (which is IMHO the correct
       solution) or a downgrade to Suggests:...

  NB2, I would have re-opened #599643 instead, but then I found this bug
       and I thought the two were linked, thus it sounds more logical to
       me replying here, at least until Bill corrected me

- it seems I am the only one who cares about 8MB of disk space, maybe it
  reminds me of the 512MB SD card I had for Debian on my Openmoko (and
  yes, there are Openmoko owners using Emacs on it)

...I will stop complaining with this mail.

Thx, bye,
Gismo / Luca
[Message part 2 (application/pgp-signature, inline)]

Information forwarded to debian-bugs-dist@lists.debian.org, Harshula Jayasuriya <harshula@gmail.com>:
Bug#604926; Package m17n-db. (Wed, 02 Feb 2011 17:18:03 GMT) Full text and rfc822 format available.

Acknowledgement sent to Harshula <harshula@gmail.com>:
Extra info received and forwarded to list. Copy sent to Harshula Jayasuriya <harshula@gmail.com>. (Wed, 02 Feb 2011 17:18:03 GMT) Full text and rfc822 format available.

Message #49 received at 604926@bugs.debian.org (full text, mbox):

From: Harshula <harshula@gmail.com>
To: Luca Capello <luca@pca.it>
Cc: 604926@bugs.debian.org, Bill Allombert <Bill.Allombert@math.u-bordeaux1.fr>, Josh Triplett <josh@joshtriplett.org>
Subject: Re: Bug#604926: libm17n-0: circular dependencies with m17n-contrib and m17n-db
Date: Thu, 03 Feb 2011 04:14:25 +1100
Hi Luca,

On Sun, 2011-01-16 at 22:37 +0100, Luca Capello wrote:
> On Sun, 09 Jan 2011 15:56:22 +0100, Harshula wrote:
> > On Wed, 2011-01-05 at 20:42 +0100, Luca Capello wrote:

> > The programs that link to the m17n library do so to use the rules
> > contained in m17n-db.
> 
> Every time these programs run?  I have not seen any Emacs error in more
> than 6 years of use because of m17n-db not being installed on my sid (I
> have APT's Install-Recommends off and pay attention to most extra
> packages are installed as Depends:).

m17n libs are typically needed for non-Latin script input and complex
text layout. The FLT files in m17n-db contain the rules that are
*required* for m17n lib to do complex text layout in Emacs. If you are
not familiar with the scripts that require complex text layout it is
unlikely you would recognise incorrect text layout.

> As a side note, now that I looked for, it is funny what upstream thinks
> about the relationship between the m17n library and database, from
> libm17n-0/1.6.1-1 /usr/share/doc/libm17n-0/README.gz:
> 
>   (2) DATABASE
> 
>   The m17n library utilizes the m17n database available at:
>           http://www.m17n.org/m17n-lib/m17n-db
>   Without this database, the m17n library loses half its value.  Please
>   install it (Ver.1.4.0 or the later is required) too before you try the
>   above sample programs or develop a program that uses the m17n library.

m17n lib exposes 5 or 6 APIs for different functionalities. One is used
for text layout and another used for input. m17n-db is required for the
aforementioned two APIs because the actual rules are contained in the
FLT and MIM files in m17n-db.

> Sorry, maybe my English is not so good, but this is how I read:
> 
>   Message-ID: <1286876519.31024.79.camel@B3.HOME>
>   URL: <http://bugs.debian.org/cgi-bin/bugreport.cgi?bug=599643#18>
> 
> --8<---------------cut here---------------start------------->8---
> On Tue, 12 Oct 2010 11:41:59 +0200, Harshula wrote:
> > On Sun, 2010-10-10 at 17:53 -0700, Josh Triplett wrote:
> >> On Mon, Oct 11, 2010 at 03:43:27AM +1100, Harshula wrote:
> >
> >> > You've raised an interesting question. My initial reaction is Emacs
> >> > should Depend on both libm17n-0 and m17n-db. Emacs appears to use
> >> > libm17n and m17n-db for complex text layout. libm17n contains the C API
> >> > and m17n-db contains the layout rules. So without both packages Emacs
> >> > will not function correctly. For example, copy the following Sinhala
> >> > text "කොහොමද" into Emacs with both libm17n-0 and m17n-db installed. Take
> >> > a screenshot. Then remove m17n-db and copy the text into Emacs and see
> >> > the difference.
> >> 
> >> Interesting.  It didn't make a difference with the default font I
> >> normally use in Emacs (Neep Alt), but with DejaVu Sans Mono the first
> >> character moved before the quote.  Does that sound like the correct
> >> behavior?
> >
> > No, that does not sound correct. I forgot to mention one important step,
> > install ttf-sinhala-lklug.
> --8<---------------cut here---------------end--------------->8---
> 
> Nevertheless, read below.
> 
> > If you are typing in a particular script, you need the relevant font
> > to see the correct results. This is applicable to other text layout
> > libraries.
> 
> To which I fully agree.

Good.

> >> According to the reasoning used to solve #599643, why does libm17n-0 not
> >> depend also on ttf-sinhala-lklug?  It does not even Recommends: it...
> >
> > Pango or ICU do not depend on particular fonts either.
> 
> Exactly, but at least libpango1.0/1.28.3-4 in experimental had the
> following in its description:
> 
>   Recommends: x-ttcidfont-conf
>   Suggests: ttf-japanese-gothic, ttf-japanese-mincho, ttf-thryomanes,
>    ttf-baekmuk, ttf-arphic-gbsn00lp, ttf-arphic-bsmi00lp,
>    ttf-arphic-gkai00mp, ttf-arphic-bkai00mp 

Well, do you see ttf-sinhala-lklug listed there? Did you also have a
look at ICU?

I'm going ahead with the plan laid out at
http://bugs.debian.org/cgi-bin/bugreport.cgi?bug=604926#10

cya,
#





Reply sent to Harshula Jayasuriya <harshula@gmail.com>:
You have taken responsibility. (Sun, 06 Feb 2011 09:39:04 GMT) Full text and rfc822 format available.

Notification sent to Bill Allombert <ballombe@debian.org>:
Bug acknowledged by developer. (Sun, 06 Feb 2011 09:39:04 GMT) Full text and rfc822 format available.

Message #54 received at 604926-close@bugs.debian.org (full text, mbox):

From: Harshula Jayasuriya <harshula@gmail.com>
To: 604926-close@bugs.debian.org
Subject: Bug#604926: fixed in m17n-db 1.6.2-2
Date: Sun, 06 Feb 2011 09:36:27 +0000
Source: m17n-db
Source-Version: 1.6.2-2

We believe that the bug you reported is fixed in the latest version of
m17n-db, which is due to be installed in the Debian FTP archive:

m17n-db_1.6.2-2.debian.tar.gz
  to main/m/m17n-db/m17n-db_1.6.2-2.debian.tar.gz
m17n-db_1.6.2-2.dsc
  to main/m/m17n-db/m17n-db_1.6.2-2.dsc
m17n-db_1.6.2-2_all.deb
  to main/m/m17n-db/m17n-db_1.6.2-2_all.deb



A summary of the changes between this version and the previous one is
attached.

Thank you for reporting the bug, which will now be closed.  If you
have further comments please address them to 604926@bugs.debian.org,
and the maintainer will reopen the bug report if appropriate.

Debian distribution maintenance software
pp.
Harshula Jayasuriya <harshula@gmail.com> (supplier of updated m17n-db package)

(This message was generated automatically at their request; if you
believe that there is a problem with it please contact the archive
administrators by mailing ftpmaster@debian.org)


-----BEGIN PGP SIGNED MESSAGE-----
Hash: SHA1

Format: 1.8
Date: Sun, 06 Feb 2011 02:26:35 +1100
Source: m17n-db
Binary: m17n-db
Architecture: source all
Version: 1.6.2-2
Distribution: unstable
Urgency: low
Maintainer: Harshula Jayasuriya <harshula@gmail.com>
Changed-By: Harshula Jayasuriya <harshula@gmail.com>
Description: 
 m17n-db    - a multilingual text processing library - database
Closes: 604926
Changes: 
 m17n-db (1.6.2-2) unstable; urgency=low
 .
   * debian/control:
       - break circular dependency (Closes: #604926).
       - Recommends: anthy, ispell
Checksums-Sha1: 
 70df0e2e10573cb8f498ca426d52ba45f9f9eeef 1076 m17n-db_1.6.2-2.dsc
 ecf4e7cb4a2bee7c513c153fbb8cc6f1064e3ce1 5205 m17n-db_1.6.2-2.debian.tar.gz
 052797bd76ca93e50d4ee8b368c7db01ea5abf96 1846646 m17n-db_1.6.2-2_all.deb
Checksums-Sha256: 
 5c88655a0a886d69c220a891e1a364b8238036ec327ba4b1dab4f7d06040ae16 1076 m17n-db_1.6.2-2.dsc
 52e9eda68b1613144d156f3548ef3514e4737b82f20c7b2cb31567bf7455e6af 5205 m17n-db_1.6.2-2.debian.tar.gz
 98dd82d16c1d71ad2ae8ec677a8c782448a70392c547b087de61949a257ece95 1846646 m17n-db_1.6.2-2_all.deb
Files: 
 811fc5d2d45d89e5b397eacefef1bb82 1076 utils optional m17n-db_1.6.2-2.dsc
 fd1b09bb11c92214272c45fdf2c2284a 5205 utils optional m17n-db_1.6.2-2.debian.tar.gz
 9b214a1309d1b0df5eb7b5f2f04997de 1846646 utils optional m17n-db_1.6.2-2_all.deb

-----BEGIN PGP SIGNATURE-----
Version: GnuPG v1.4.10 (GNU/Linux)

iEYEARECAAYFAk1NfC8ACgkQnXMZMWIGYYyfVQCgtSQpeOAkLPTMprjnBt3M6LlY
O5QAoKMC+0eREdqBmcR/eLxkJIBrROse
=QqCO
-----END PGP SIGNATURE-----





Bug archived. Request was from Debbugs Internal Request <owner@bugs.debian.org> to internal_control@bugs.debian.org. (Wed, 16 Mar 2011 07:38:07 GMT) Full text and rfc822 format available.

Send a report that this bug log contains spam.


Debian bug tracking system administrator <owner@bugs.debian.org>. Last modified: Mon Apr 21 16:11:46 2014; Machine Name: buxtehude.debian.org

Debian Bug tracking system
Copyright (C) 1999 Darren O. Benham, 1997,2003 nCipher Corporation Ltd, 1994-97 Ian Jackson.